function [Xreturn,X1,mycost1,mycost2] = convex_cvx( Ksize, Ax, y,epsilon,reg_n,reg_f)

[mycost1,mycost2] = deal(0); r = 1;

Ksize = num2cell(Ksize,1);
[n1,n2,S,R,m,~] = deal(Ksize{:});

%% optimization
    cvx_begin quiet
    variable X(n1, n2*R, S) complex
    
    % objective function
    expression obj
    obj = 0;
    for iS =1:S
       tmp1 = X(:,:,iS);
        obj = obj + reg_n * norm_nuc(tmp1) + reg_f * norm(tmp1,'fro');
    end
    
    
    minimize obj
    
    % constraints
    expression y_p(m, R)
    for jR = 1:R
         tmp2 = X(:,(jR-1)*n2+1:jR*n2,:);
         y_p(:,jR) = Ax{jR}*tmp2(:);
    
    end
    
    subject to
      norm(y_p-y,'fro')<= epsilon
         
    cvx_end

    
X1 = reshape(arrayfun(@(len)X(:,:,len),1:S,'Uni',0),[S,1]);
[Xreturn]=deal(cell(S,1));
norm_one = zeros(S,1);

for idx = 1:S
    rx = 1;
    [u,s,v] = svd(X1{idx});
    mycost1 = mycost1 + sum(s(rx+1:end,rx+1:end));
    norm_one(idx,1) = norm(X1{idx},'fro');
    s(rx+1:end,rx+1:end)=0;
    Xreturn{idx}=u*s*v';
    
end
end


