function [A,B,FC,Ax]= generate_decon_matrix(Ksize,C)
% B m x n2 low-frequemcy DFT
% A n1 x n2 x*h^*
% Detailed explanation goes here

Ksize = num2cell(Ksize,1);
[n1,n2,S,R,m,~] = deal(Ksize{:});

[A,FC]=deal(cell(R,S));
Ax = cell(R,1);

F = dftmtx(m)/sqrt(m);
B = F(:,1:n2);


for iR = 1:R
    
    for jS=1:S
        Ck = F*C{jS};
        FC{jS} = Ck;
        
        Ak = zeros(m,n1*n2);
        for ri=1:m
            tmp = Ck(ri,:)'*conj(B(ri,:));
            Ak(ri,:)=tmp(:)';
        end
        A{iR,jS} = Ak;
        
        
    end
    
      Ax{iR} = horzcat(A{iR,:});
    
end

end

