
 clear 
 clc;
addpath('./function');

[nTest,DEVICE_SIZE,n1,n2,RECEIVER_SIZE] = deal(20,10,20,5,3);
noiseVarianceSet = 0;
inactiveDeviceSize = 6;
timeSlotSet =[65:20:700];
[REG_NUCLEAR, REG_L1L2] = deal(1,0);
rk = 1;
ParameterSet = struct('ranktol',{1e-5},'maxiter',{100},'verbosity',{0});
ParameterSet.costtol = 1e-6;
ParameterSet.tolgradnorm = 1e-8;
ParameterSet.eps = 1e-3;
ParameterSet.lambda = 0.08;

[nTimeSlot,nNoiseVariance] = deal(length(timeSlotSet),length(noiseVarianceSet));

[allcost2, allcost2_ori,allcost3, allcost3_ori,allcost4, allcost4_ori,allcost5, allcost5_ori] = deal(zeros(nTimeSlot,nNoiseVariance,nTest));

save('test/parameterArray.mat');

for iTimeSlot = 1 : nTimeSlot
    
   timeSlot = timeSlotSet(iTimeSlot);
    
for jVariance = 1:nNoiseVariance
    
        noiseVariance = noiseVarianceSet(jVariance);
        Ksize = [n1,n2,DEVICE_SIZE,RECEIVER_SIZE,timeSlot,noiseVariance];
        
        [X,y,C,xx,h,g,z,y1,y_noise,idx] = deal(cell(nTest,1));
        [A,FB,FC,X0_dc,Ax,epsilon] = deal(cell(nTest,1));
        dirname = [num2str(timeSlot)];
        mkdir ('test/',dirname);
        
        [Xout2_ori,Xout2,Xout3_ori,Xout3,Xout4_ori,Xout4,Xout5_ori,Xout5] = deal(cell(nTest,1));
        [FuncDC,FuncNNM,FuncLMN,FuncMNM,Functrue] = deal(cell(nTest,1));
        
        parfor kTest = 1:nTest
           
            fid2 = fopen('test/main_print2.txt','a+');
            fid3 = fopen('test/main_print3.txt','a+');
            fid4 = fopen('test/main_print4.txt','a+');
            fid5 = fopen('test/main_print5.txt','a+');
           [X{kTest},y{kTest},C{kTest},xx{kTest},h{kTest},g{kTest},z{kTest},y1{kTest},y_noise{kTest},idx{kTest},X0_dc{kTest} ] = generate_model(Ksize,inactiveDeviceSize);
           [A{kTest},FB{kTest},FC{kTest},Ax{kTest}] = generate_decon_matrix(Ksize,C{kTest});
           
           % epsilon{kTest} = 1e-2;
            
           epsilon{kTest} = 0;
            
           % truetheta = reshape(arrayfun(@(len) horzcat(X{kTest}{:,len}),1:DEVICE_SIZE,'Uni',0),[DEVICE_SIZE,1]);
            
            truevalue = sqrt(sum(cellfun(@(x,y)norm(x,'fro')^2,X{kTest})));
            
            Functrue{kTest}.trueValue = truevalue;Functrue{kTest}.trueTheta = X{kTest};
%% 3 nuclear norm Minimation
            [Xout3{kTest},Xout3_ori{kTest},func3_nuc,func3_F]= convex_cvx( Ksize, Ax{kTest}, y_noise{kTest},epsilon{kTest},1,0);
             
            FuncNNM{kTest} = struct('nucNorm',{func3_nuc},'fNorm',{func3_F});
            
            allcost3(iTimeSlot,jVariance,kTest)=sqrt(sum(cellfun(@(x,y)norm(x-y,'fro')^2,Xout3{kTest},X{kTest})))/truevalue;
            allcost3_ori(iTimeSlot,jVariance,kTest)=sqrt(sum(cellfun(@(x,y)norm(x-y,'fro')^2,Xout3_ori{kTest},X{kTest})))/truevalue;
            fprintf(fid3,'NuclearNorm: test:%.3d,size:%.3d,SNR:%.3d, cost_ori:%.4e, cost:%.4e\n', kTest,timeSlot,jVariance,allcost3_ori(iTimeSlot,jVariance,kTest),allcost3(iTimeSlot,jVariance,kTest));
 
 %% 4 L1L2 norm Minimation
            [Xout4{kTest},Xout4_ori{kTest},func4_nuc,func4_F]= convex_cvx( Ksize, Ax{kTest}, y_noise{kTest},epsilon{kTest},0,1);
             
            FuncLMN{kTest} = struct('nucNorm',{func4_nuc},'fNorm',{func4_F});
            
            allcost4(iTimeSlot,jVariance,kTest)=sqrt(sum(cellfun(@(x,y)norm(x-y,'fro')^2,Xout4{kTest},X{kTest})))/truevalue;
            allcost4_ori(iTimeSlot,jVariance,kTest)=sqrt(sum(cellfun(@(x,y)norm(x-y,'fro')^2,Xout4_ori{kTest},X{kTest})))/truevalue;
            fprintf(fid4,'L1L2Norm: test:%.3d,size:%.3d,SNR:%.3d, cost_ori:%.4e, cost:%.4e\n', kTest,timeSlot,jVariance,allcost4_ori(iTimeSlot,jVariance,kTest),allcost4(iTimeSlot,jVariance,kTest));
  %% 5 mixednorm Minimation
            [Xout5{kTest},Xout5_ori{kTest},func5_nuc,func5_F]= convex_cvx( Ksize, Ax{kTest}, y_noise{kTest},epsilon{kTest},200,1);
             
            FuncMNM{kTest} = struct('nucNorm',{func5_nuc},'fNorm',{func5_F});
            
            allcost5(iTimeSlot,jVariance,kTest)=sqrt(sum(cellfun(@(x,y)norm(x-y,'fro')^2,Xout5{kTest},X{kTest})))/truevalue;
            allcost5_ori(iTimeSlot,jVariance,kTest)=sqrt(sum(cellfun(@(x,y)norm(x-y,'fro')^2,Xout5_ori{kTest},X{kTest})))/truevalue;
            fprintf(fid5,'MixedNorm: test:%.3d,size:%.3d,SNR:%.3d, cost_ori:%.4e, cost:%.4e\n', kTest,timeSlot,jVariance,allcost5_ori(iTimeSlot,jVariance,kTest),allcost5(iTimeSlot,jVariance,kTest));
          
%% 2  DC    
            [Xout2{kTest},Xout2_ori{kTest},func2_nuc] = mimoblinddemixing(Ksize, X0_dc{kTest}, Functrue{kTest},Ax{kTest}, y_noise{kTest}, ParameterSet,epsilon{kTest});
                        
            FuncDC{kTest} = struct('nucNorm',{func2_nuc});
            
             
            allcost2(iTimeSlot,jVariance,kTest)=sqrt(sum(cellfun(@(x,y)norm(x-y,'fro')^2,Xout2{kTest},X{kTest})))/truevalue;
            allcost2_ori(iTimeSlot,jVariance,kTest)=sqrt(sum(cellfun(@(x,y)norm(x-y,'fro')^2,Xout2_ori{kTest},X{kTest})))/truevalue;
            
            fprintf(fid2,'DC: test:%.3d,size:%.3d,SNR:%.3d, cost_ori:%.4e,cost:%.4e\n', kTest,timeSlot,jVariance,allcost2_ori(iTimeSlot,jVariance,kTest),allcost2(iTimeSlot,jVariance,kTest));
      
            fclose(fid2); 
            fclose(fid3); 
            fclose(fid4); 
            fclose(fid5); 
        end
        save([['test/',dirname,'/'],['initial.mat']],'X','y','C','xx','h','g','z','y1','y_noise','A','FB','FC','X0_dc','Ax','epsilon', 'Ksize','idx','Functrue');
        save([['test/',dirname,'/'],['DC_nuclear.mat']],'FuncDC','Xout2_ori','Xout2');
        save([['test/',dirname,'/'],['NNM.mat']],'FuncNNM','Xout3_ori','Xout3');
        save([['test/',dirname,'/'],['L1L2.mat']],'FuncLMN','Xout4_ori','Xout4');
        save([['test/',dirname,'/'],['MNM.mat']],'FuncMNM','Xout5_ori','Xout5');
        save([['test/',dirname,'/'],['cost.mat']],'allcost2','allcost2_ori','allcost3','allcost3_ori','allcost4','allcost4_ori','allcost5','allcost5_ori');
         
       
end
         
end

