% the ManOpt tool needs to be installed via running manopt/importmanopt.m
clear all;
clc
%rng('default');rng(1);
warning off;
addpath('./fun');
testnum =1;
size_set =[200];
size_len = length(size_set);
s = 10;
lambda_set =[0.01];
lambd_len = length(lambda_set);

sparse=7;
n1 = 10; n2 =10;

r=1;
params.verbosity =0;
params.costtol = 1e-6;
params.maxiter = 5000;
params.tolgradnorm = 1e-6;
params.innerstepsize = 0.1;
params.eps = 1e-3;

allcost1 = zeros(size_len,lambd_len,testnum);
allcost2 = zeros(size_len,lambd_len,testnum);
allcost3 = zeros(size_len,lambd_len,testnum);
allcost4 = zeros(size_len,lambd_len,testnum);

for t=1:size_len
    m = size_set(t);
    for ks = 1:lambd_len
        Ksize = [n1,n2,s,m];
        params.lambda = lambda_set(ks);
    for ki = 1:testnum
        [X,y,C,x,h,g,z,y1 ] = generate_model( m,n1,n2,s,sparse);
        [A,B,FC] = generate_decon_matrix(m,n1,n2,s,C);   
%% initial        
        
        X0_ra = cell(s,1);
        for i = 1:s
            X0_ra{i} = (randn(n1+n2,1)+1i*randn(n1+n2,1))/sqrt(2*n1);
            X0_ra{i} =  X0_ra{i}/norm( X0_ra{i})*sqrt(2);
            
        end
        
        
%% nuclear
%         Xout1 = convex_cvx1( Ksize, A, y,1,0,0);
%         allcost1(t,ks,ki)=sqrt(sum(cellfun(@(x,y)norm(x-y,'fro')^2,Xout1,X))/sqrt(sum(cellfun(@(x,y)norm(x,'fro')^2,X))));
%         fprintf('CVX: m:%.3d, K:%.2d, test:%.3d, cost:%.4e\n',m,s, ki,allcost1(t,ks,ki));
% %% frobius
%         Xout2 = convex_cvx1( Ksize, A, y,0,1,0);
%         allcost2(t,ks,ki)=sqrt(sum(cellfun(@(x,y)norm(x-y,'fro')^2,Xout2,X))/sqrt(sum(cellfun(@(x,y)norm(x,'fro')^2,X))));
%         fprintf('m:%.3d, K:%.2d, test:%.3d, cost:%.4e\n',m,s,ki,allcost2(t,ks,ki));
% 
% %% combine
%         Xout3 = convex_cvx1( Ksize, A, y,0.3,0.5,0);
%         allcost3(t,ks,ki)=sqrt(sum(cellfun(@(x,y)norm(x-y,'fro')^2,Xout3,X))/sqrt(sum(cellfun(@(x,y)norm(x,'fro')^2,X))));
%         fprintf('m:%.3d, K:%.2d, test:%.3d, cost:%.4e\n',m,s, ki,allcost3(t,ks,ki));
        
        
%%  RTR   
     
        [Xout4, infos1]=Riemannian_fixedrank_TR(r, Ksize,X0_ra, params, A, y);
        x1 = cellfun(@(x,y)x(1:n1,:)*x(n1+1:end,:)',Xout4,'Uni',0);
        allcost4(t,ks,ki)=sqrt(sum(cellfun(@(x,y)norm(x(1:n1,:)*x(n1+1:end,:)'-y,'fro')^2,Xout4,X))/sum(cellfun(@(x,y)norm(x,'fro')^2,X)));
        fprintf('RTR: m:%.3d, K:%.2d, test:%.3d, cost:%.4e\n',m,s, ki,allcost4(t,ks,ki));


     end
     end
end

tol = 1e-2;
test_succ1 = sum(allcost1<tol,3)/testnum;
test_succ2 = sum(allcost2<tol,3)/testnum;
test_succ3 = sum(allcost3<tol,3)/testnum;
test_succ4 = sum(allcost4<tol,3)/testnum;

% filename = './data/rtr_cvx_com_1018_4';
% save([filename '.mat']);
% % 

for i = 1:size(test_succ1,2)
figure,
plot(size_set,test_succ1,'s-','LineWidth',1.5);hold on
plot(size_set,test_succ2,'s-','LineWidth',1.5);hold on
plot(size_set,test_succ3,'s-','LineWidth',1.5);hold on
plot(size_set,test_succ4,'s-','LineWidth',1.5);hold on

legend('nuclear','fro','com','rtr');
xlabel('size_m','FontSize',14);
ylabel('Probability of sucessful recovery','FontSize',14);
axis tight;

end




% close all
