L_set = 20;
MonteCarlo = 1e2;
K = 10;
N = 200;
M = 3;


N_md = zeros(length(L_set),1);
N_fa = zeros(length(L_set),1);
P_md = zeros(length(L_set),1);
P_fa = zeros(length(L_set),1);

for i = 1:length(L_set)
    display(strcat('L_idx=',num2str(i)));
    L = L_set(i);
    D_channel = zeros(N,MonteCarlo);
    D_act = false(N,MonteCarlo);
    D_signal = zeros(N,M,MonteCarlo);
    D_absxmm = zeros(N,MonteCarlo);
    D_tau = zeros(MonteCarlo,1);
    imc = 1;
    while imc <= MonteCarlo
        display(strcat('Mc_idx=',num2str(imc)));
        
        A = randn(L,N)*(1/L)^0.5*sqrt(1/2) + sqrt(-1)*randn(L,N)*(1/L)^0.5*sqrt(1/2);
%         A = randn(L,N)*(1/L)^0.5;
        supp = randperm(N);
        D_act(supp(1:K),imc) = true;
      
        x_user = 2*(rand(N,1)-0.5)*500*sqrt(2);
        y_user = 2*(rand(N,1)-0.5)*500*sqrt(2);
        distance = zeros(N,1);
        for n=1:N
            distance(n) = sqrt(x_user(n)^2 + y_user(n)^2);
        end
        path_loss = zeros(N,1);
        for n=1:N
            path_loss(n) = 10^((-128.1 - 37.6*log10(distance(n)*1e-3))/10);
        end
        
        power = 10^(2.3)*10^(-3);
        noise_power = 10^(-16.9)*10^(-3);
        B = 5e7;
        noise = noise_power*B;
%         path_loss = path_loss/noise;
%         noise = 1;
        
        D_channel(:,imc) = path_loss;

        h=zeros(N,M);
        for n=1:N
            h(n,:) = sqrt(1/2)*(randn(1,M) + sqrt(-1)*randn(1,M))*sqrt(path_loss(n));
%             h(n,:) = randn(1,M)*sqrt(path_loss(n));
        end


        x = zeros(N,M);
        for m=1:M
            x(supp(1:K),:) = h(supp(1:K),:);
        end
        
        w = randn(L,M)*sqrt(1/2) + sqrt(-1)*randn(L,M)*sqrt(1/2);
%         w = randn(L,M);
        

        
        noise_r = noise/power/L;
        sigma_w = sqrt(noise_r);
        

        
        y = A*x + w*sigma_w;
        
       [xnoise,xhat,mse,tau_real,tau_est] = noisyCAMPmmseforKLS(A,N,M,L,y,x,50,K/N,path_loss,sigma_w);
       
        D_tau(imc) = tau_est(end);
        
        D_signal(:,:,imc) = xnoise;
        for n = 1:N
            D_absxmm(n,imc) = norm(D_signal(n,:,imc));
        end
        imc = imc + 1;
        
       

    end
    for imc = 1:MonteCarlo 
        for n = 1:N
            t = M*log(1+path_loss(n)/D_tau(imc)^2)/(1/D_tau(imc)^2-1/(path_loss(n)+D_tau(imc)^2));
            if D_absxmm(n,imc)^2 < t && D_act(n,imc) == 1
                N_md(i) = N_md(i) + 1;
            end
            if D_absxmm(n,imc)^2 > t && D_act(n,imc) == 0
                N_fa(i) = N_fa(i) + 1;
            end
        end
    end
    
%     t_min = 0;
%     t_max = 1;
%     tolerance = 1e-15;
%     while t_max - t_min >= tolerance
%         t = (t_max + t_min)/2;
%         N1 = 0;
%         N2 = 0;
%         for imc = 1:MonteCarlo 
%             for n=1:N
%                 if D_absxmm(n,imc) < t && D_act(n,imc) == 1
%                     N1 = N1 + 1;
%                 end
%                 if D_absxmm(n,imc) > t && D_act(n,imc) == 0
%                     N2 = N2 + 1;
%                 end
%             end
%         end
%         if N1/(K*MonteCarlo) > N2/((N-K)*MonteCarlo)
%             t_max = t;
%         else
%             t_min = t;
%         end
%     end
%     N_md(i) = N1;
%     N_fa(i) = N2;
    P_md(i) = N_md(i)/(K*MonteCarlo);
    P_fa(i) = N_fa(i)/((N-K)*MonteCarlo);

    
end


L=L_set;
figure
plot(L,P_md,'ko-',L,P_fa,'k+-');
grid on
xlabel('Pilot Sequence Length: {\it L}');
ylabel('Activity Detection Error Probability');
legend('{\it P}^{MD}: MMSE Denoiser','{\it P}^{FA}: MMSE Denoiser');

